<?php

include '../core.php';

cabecera (4);

$command = $_POST['command'];

switch ($command) {

   default:

      $dirBase = $crlDir;
      $date = "crl_d".date('dmY')."t".date('His');

      echo "<h1 class='title'>Generaci&oacute;n de Lista de Certificados Revocados</h1>

      <form method='post' action='' enctype='multipart/form-data' name='csr_chk_pin'>
      <div id='tbox'>
        <h3 class='head_a2b1'>Generacin CRL</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Pass Phrase:</div>
            <div id='tvalue'><input type='password' name='pass_phrase' size='25' /></div>
          </div>
          <div id='trow'>
            <div id='tvalue'>
              <input class='button' type='submit' value='Generar CRL' />
            </div>
          </div>
        </div>
      </div>
      <input type='hidden' name='command' value='gen_crl' />

      </form>\n";

      break;

   case "gen_crl":

      $dirBase = $crlDir;
      $date = "crl_d".date('dmY')."t".date('His');
      $anioCrl = substr($date, 9,4);
      $mesCrl = substr($date, 7, 2);
      $diaCrl = substr($date, 5, 2);
 
      if (!is_dir($dirBase . $anioCrl)) {
         $dirBase = $dirBase . $anioCrl ."/";
         mkdir($dirBase, 0744);
      }
      else {
         $dirBase = $dirBase . $anioCrl ."/";
      }

      if (!is_dir($dirBase . $anioCrl . $mesCrl)) {
         $dirBase = $dirBase . $anioCrl . $mesCrl . "/";
         mkdir($dirBase, 0744);
      }
      else {
         $dirBase = $dirBase . $anioCrl . $mesCrl . "/";
      }

      if (!is_dir($dirBase . $anioCrl . $mesCrl .$diaCrl)) {
         $dirBase = $dirBase . $anioCrl . $mesCrl . $diaCrl . "/";
         mkdir($dirBase, 0744);
      }
      else {
         $dirBase = $dirBase . $anioCrl . $mesCrl . $diaCrl . "/";
      }

      if (!is_dir($dirBase . $date)) {
         mkdir($dirBase . $date, 0744);
      }

      $completDir = $dirBase . $date . "/";
      echo "<pre>\n";
   
      $opensslCommand = "pkirisID=NULL pkirisEMAIL=NULL /usr/bin/openssl ca -gencrl -config /var/ssl/CA/openssl/openssl.cnf -key $pass_phrase -out $completDir$date.pem 2>&1";
      $result = system($opensslCommand,$retVal);

      if ( $retVal == 1 ) {
         $errorDescription = $errorDescription . "\nNo se ha podido generar la lista de revocaci&oacute;n.";
         $errorNumber = 69;
         $errorCounter++;   
      }
      else {
         $opensslCommand2 = "pkirisEMAIL=NULL /usr/bin/openssl crl -inform PEM -outform DER -in $completDir$date.pem -out $completDir$date.der";
         $result2 = system($opensslCommand2,$retVal2);
   
         if ( $retVal2 == 1 ) {
            $errorDescription = $errorDescription . "\nNo se ha podido generar la lista de revocaci&oacute;n en formato der.";
            $errorNumber = 69;
            $errorCounter++;
         }
         else {
            $opensslCommand3 = "pkirisEMAIL=NULL /usr/bin/openssl crl -in $completDir$date.pem -text -out $completDir$date.txt";
            $result3 = system($opensslCommand3,$retVal3);

            if ( $retVal3 == 1 ) {
               $errorDescription = $errorDescription . "\nNo se ha podido generar la lista de revocaci&oacute;n en formato texto.";
               $errorNumber = 69;
               $errorCounter++;
            }
         }
      }
      // Si no ha habido ningun error desde el principio del codigo:
      if ($errorCounter == 0)
         echo "<p>La gesti&oacute;n de las solicitudes se ha realizado con &eacute;xito.</p>";
      else {
         echo "<h1>Error generando la lista de revocaci&oacute;n</h1>
               <p>$errorDescription Error $errorNumber</p>";
         rmdir ($dirBase . $date);
      }
      echo "</pre>\n";

      // Escribimos en el fichero de log los cambios de estado realizados
      $user = "CA-Admin";
      $status = "gen-crl";
      writeLog ($status, $copa, $user, $errorNumber);

      break;
}

pie ();

?>
