<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

echo "<h1 class='title'>Baja de Autoridad de Registro</h1>";

//$command = $_POST["command_delra"];

switch ( $command ) {
   default :
      echo "<h2>Seleccione la RA que quiere dar de baja</h2>\n";

      // Buscamos todas las RA disponible en el sistema
      $filter = "(objectClass=pkirisAuthority)";
      $justthese = array("pkirisName","pkirisCopaID","description");
      $result = ldap_get_info($base, $filter, $justthese);

      if (!$result){
         $error = 69;
         echo "<h2>No se ha encontrado ninguna Autoridad de Registro en el sistema.</h2>";
      }
      else {
         echo "<table border='0' cellpadding='0' cellspacing='0' !width='100%'>
         <tr>
	 <td class='header'>Copa Id</td>
	 <td class='header'>Nombre de la RA</td>
	 <td class='header'>Descripci&oacute;n</td>
	 <td class='header'>Certificados Activos</td>
	 <td class='header'>Peticiones enviadas a la CA</td>
	 </tr>\n";

         for($i = 0; $i < $result["count"]; $i++) {
         $queryCopa = $result[$i]["pkiriscopaid"][0];
         $queryRaName = $result[$i]["pkirisname"][0];
         $queryDescr = $result[$i]["description"][0];

	 $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$queryCopa*)(pkirisStatus=issued))";
         $justthese = array("dn");
         $certIssued = ldap_get_info($base, $filter, $justthese);

	 $certIssuedNum = count($certIssued) -1;

	 $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$queryCopa*)(pkirisStatus=ra2ca)(pkirisStatus=revoke))";
         $justthese = array("dn");
         $certRa2ca = ldap_get_info($base, $filter, $justthese);

         $certRa2caNum = count($certRa2ca) -1;

	 $certTotalNum = $certIssuedNum + $certRa2caNum;

         if ($i%2==0) {
	   echo "<tr>
           <td class='even'> $queryCopa </td>
           <td class='even'><a href='delRa.php?copa=$queryCopa&command=have_copa&certs=$certTotalNum'> $queryRaName </a></td>
           <td class='even'> $queryDescr </td>
           <td class='even'> $certIssuedNum </td>
           <td class='even'> $certRa2caNum </td>
           </tr>";
	 }
	 else {
            echo "<tr>
	    <td class='even'> $queryCopa </td>
	    <td class='even'><a href='delRa.php?copa=$queryCopa&command=have_copa&certs=$certTotalNum'> $queryRaName </a></td>
	    <td class='even'> $queryDescr </td>
	    <td class='even'> $certIssuedNum </td>
	    <td class='even'> $certRa2caNum </td>
	    </tr>";
	 }   

	 }
         echo "</table>
	 <p>No podra borrar una RA en la cual todav&iacute;a se encuentren certificados activos o peticiones enviadas a la CA, como por ejemplo revocaciones, peticiones de firma/renovaci&oacute;n, etc.</p>";
      }
      break;

      case "have_copa":
	 if ($certs > 0) {
            echo "<p>No se puede borrar la RA porque existen Certificados validos o peticiones en curso, por favor verifique que esten todos los certificados revocadors o expirados y vuelva a intentar la baja.</p>";
	 }
	 else {
            $filter = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$copa))";
            $justthese = array("dn","pkirisName","pkirisRaUrl");
            $result = ldap_get_info($base, $filter, $justthese);
	
	    $delRaDn = $result[0]["dn"][0];
            $delRaName = $result[0]["pkirisname"][0];
            $delRaUrl = $result[0]["pkirisraurl"][0];
	    
	    $filter = "(pkirisCopaID=$copa*)";
            $justthese = array("dn");
            $result = ldap_get_info($base, $filter, $justthese);

	    for($i=0; $i<count($result)-1; $i++) {
	       $delResult=ldap_del_record($result[$i]["dn"]);
            }
				  
	    if ($delResult) { 
	       // Borramos el archivo de configuracion
	       $delConfFile = unlink($confDir."php/".$delRaUrl.".conf");
	       if ($delConfFile) {
	          // Borramos el link simbolico 
		  $delLinkFile = unlink($rootDir.$delRaUrl);
		  if ($delLinkFile) {
	             echo "<p>La baja de la Autoridad de Registro \"$delRaName\" se ha realizado con &eacute;xito.</p>";
                  }
               }
	    }
	    else {
            }
         }
      break;
}
											      
pie ();

?>
